# Contributing to Veles
## How can I contribute?
### Reporting bugs
If you found a bug in Veles please check first if the problem has been already
reported. Gather following information:
* Veles version (Help/about)
* operating system and OS version
  * Linux - output of `uname -a`  and `cat /etc/os-release`
  * MacOSX - output of `uname -a` and `sw_vers -productVersion`
  * Windows - use this [guide](https://support.microsoft.com/en-us/help/13443/windows-which-operating-system)
* if running on Linux or MacOSX - output of `glxinfo | grep string`
* steps how to reproduce the problem

And create an issue on GitHub.

### Submiting changes
Please send GitHub pull request with a clear list of what you've done. Please
follow [Google C++ Style
Guide](https://google.github.io/styleguide/cppguide.html) and make sure all of
your commits are atomic (one feature per commit).

Always write a clear log message for your commits describing the change.
One-liners are fine for small, obvious changes, but bigger changes should have
longer commit messages.

More information about pull request you can find
[here](https://guides.github.com/activities/contributing-to-open-source/#contributing).

You **NEED** to have a signed CLA sent to CodiLime before your code can be
merged. You can download one from [Contributor License
Aggrement](https://www.codisec.com/cla), sign and send back to us. You can
open a pull request and have it reviewed, while we process your CLA.

Thanks for taking your time to contribute to Veles,

Veles Team
